// ball-splatting fragment shader


uniform sampler2D sampler;



vec3 float2rgb(float value)					//simple color-coding routine
{
   const float dx = 0.8;
   vec3 col;
   
   if (value<0.0) value=0.0;
   if (value>1.0) value=1.0;
   
   value = (6.0-2.0*dx)*value+dx;
   col.r = max(0.0,(3.0-abs(value-4.0)-abs(value-5.0))/2.0);
   col.g = max(0.0,(4.0-abs(value-2.0)-abs(value-4.0))/2.0);
   col.b = max(0.0,(3.0-abs(value-1.0)-abs(value-2.0))/2.0);
   
   return col;
}


void main()
{	
	vec4 tex = texture2D(sampler, gl_TexCoord[0].xy);

	float z = tex.x + 0.00390625 * tex.y + 0.00001538 * tex.z;		

	vec3 col = (gl_Color.w==0.0)? vec3(1,1,1) : float2rgb(gl_Color.y);

	//outputs
	
	gl_FragColor = vec4(col.r*tex.w, col.g*tex.w, col.b*tex.w, z);

	gl_FragDepth = gl_FragCoord.z - z*gl_Color.x;
}

