#pragma once

#include "Volume.h"
#include "Point3d.h"
#include <vector>



class VoxelSurface						//A simple surface consisting of a 'layer' of voxels. 
{										//
public:

						VoxelSurface(const Volume<float>& input,float threshold);
						//Creates a surface by thresholding a scalar volume with a given scalar isovalue

void					cut(const Volume<float>& volume_to_cut);
						//Cut with the current surface through given volume. 
						//Copy the encountered scalars at the surface points.

float					getScalarMin() const
						{ return scalar_min; }

float					getScalarMax() const
						{ return scalar_max; }
						
int						getWidth() const
						{ return width; }

int						getHeight() const
						{ return height; }

int						getDepth() const
						{ return depth; }

std::vector<Point3d>    points;			//input surface points  (estimated from volume by thresholding)
std::vector<Point3d>    normals;		//input surface normals (estimated from the above points)

protected:

float					scalar_min;
float					scalar_max;
int						width,height,depth;
};

					
